SystemOrganization addCategory: #'Cache-Visual-Analysis'!

Object subclass: #CachingVarFigures
	instanceVariableNames: 'cacheCollection imageInfo container cacheSet filePath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Visual-Analysis'!

!CachingVarFigures methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/29/2015 11:55'!
averageAndDeviation: aCollection

	| average deviation |
	average := aCollection average asFloat.
	deviation := ((aCollection 
		detectSum: [ :each | (each - average) * (each - average) ]) 
			/ aCollection size) sqrt.
			
	^ average -> deviation
	! !

!CachingVarFigures methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/26/2015 20:37'!
cachingImplPropertiesGraph! !

!CachingVarFigures methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/29/2015 12:51'!
cachingProtocolsGraph

	 | b ds stats protocolToOccurencesDict|
	protocolToOccurencesDict := Dictionary new.
	stats := cacheSet asOrderedCollection flatCollect: [ :cvar | cvar protocols ].
	stats do: [ :selector | 
				protocolToOccurencesDict at: selector put: (protocolToOccurencesDict at: selector ifAbsentPut: [ 0 ]) + 1.
	].
	
	b := RTGrapher new.
	b extent: 500 @ 200.

	ds := RTData new.
	ds interaction highlight.
	ds points: protocolToOccurencesDict keys.
	ds barShape width: 10.
	ds y: [:x | protocolToOccurencesDict at: x].
	ds barShape 
		rectangle color: Color blue; 
		width: 10.
	ds barChartWithBarTitle: #name rotation: -45 color: Color black.
	b add: ds.

	b axisY.
	b axisX noTick; noLabel.
	b axisY noDecimal; title: 'Number of Occurences'.
	b build.
	b view setDefaultMenu; open.
	^ b view! !

!CachingVarFigures methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/29/2015 15:00'!
cachingSelectorsGraph

	| b stats selectorToOccurencesDict|
	selectorToOccurencesDict := Dictionary new.
	stats := cacheSet asOrderedCollection flatCollect: [ :cvar | cvar selectors ].
	stats do: [ :selector | 
				selectorToOccurencesDict at: selector put: (selectorToOccurencesDict at: selector ifAbsentPut: [ 0 ]) + 1.
	].
	
	b := RTDoubleBarBuilder new.
	"b extent: 500 @ 200."

	b points: (selectorToOccurencesDict keys 
					sort: [:key1 :key2 | (selectorToOccurencesDict at: key1) <= (selectorToOccurencesDict at: key2)]).  .
	b bottomValue: [:x | selectorToOccurencesDict at: x] titled: 'occurences'.
	"b topValue: #numberOfVariables".
	"b axisX noTick; noLabel."
	b build.
	b view setDefaultMenu; open.
	"RTPDFExporter new exportCanvas: b view canvas onFileName: filePath ,'cachingVarsKinds.pdf'."
	^ b view! !

!CachingVarFigures methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/29/2015 13:17'!
cachingValuesGraph


	| b ds stats classToTracesDict|
	classToTracesDict := Dictionary new.
	stats := cacheSet asOrderedCollection collect: [ :cvar | cvar values ].
	stats do: [ :classSet | 
		classSet do: [ :class | 
				(class isKindOf: Symbol)
					ifTrue: [classToTracesDict at: class put: (classToTracesDict at: class ifAbsentPut: [ 0 ]) + 1]
					ifFalse: "literal" [classToTracesDict at: class class name asSymbol put: (classToTracesDict at: class class name asSymbol ifAbsentPut: [ 0 ]) + 1]
		]	
	].
	classToTracesDict inspect.
	stats inspect.
	b := RTGrapher new.
	b extent: 500 @ 200.

	ds := RTData new.
	ds interaction highlight.
	ds points: classToTracesDict keys.
	ds barShape width: 10.
	ds y: [:x | classToTracesDict at: x].
	ds barShape 
		rectangle color: Color blue; 
		width: 10.
	ds barChartWithBarTitle: #name rotation: -45 color: Color black.
	b add: ds.

	b axisY.
	b axisX noTick; noLabel.
	b axisY noDecimal; title: 'Number of Vars'.
	b build.
	b view setDefaultMenu; open.
	^ b view! !

!CachingVarFigures methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/29/2015 11:13'!
cachingVarsDensityGraph

|b2   ds detectorStats |

detectorStats := self packageAnalysisDensityOfCaches.


b2 := RTGrapher new.
"b2 view: c view.
b2 extent: 200 @ 150."

ds := RTData new.
"ds interaction popup."
ds dotShape circle color: Color red.
ds points: detectorStats associations.
"ds x: [ :point | point key ]."
ds y: [ :point | point value ].
ds connectColor: Color blue.
"ds barShape rectangle color: Color lightBlue."
b2 add: ds.
"b2 axisX; axisYWithNumberOfTicks: 4.
"
b2 axisX noDecimal; title: 'PkgGroup-ID'.
b2 axisY title: 'Caches per Class'.
b2 build.
b2 view setDefaultMenu; open.
^ b2 view! !

!CachingVarFigures methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/8/2015 14:09'!
cachingVarsKinds

	| b  stats  |
	b := RTDoubleBarBuilder new.
	stats := Dictionary new.
	stats 
		at: 'Instance Variables' 
		put: (cacheSet select: [:cvar | cvar class = InstanceSideCachingVariable]) size. 
	stats 
		at: 'Class-Side Variables' 
		put: (cacheSet select: [:cvar | cvar class = ClassSideCachingVariable]) size.
	stats 
		at: 'Shared Variables' 
		put: (cacheSet select: [:cvar | cvar class = SharedCachingVariable]) size.			
	stats 
		at: 'Temporary Variables' 
		put: (cacheSet select: [:cvar | cvar class = TempCachingVariable]) size.
	b points: stats keys.
	b bottomValue: [:x | stats at: x] titled: 'occurences'.
	"b topValue: #numberOfVariables".
	"b axisX noTick; noLabel."
	b build.
	self fixColoringFor: b.
	b view open.
	PNGReadWriter 
		putForm: b view canvas morph imageForm 
		onFileNamed: thisContext method selector asString.
	"RTPDFExporter new exportCanvas: b view canvas onFileName: filePath ,'cachingVarsKinds.pdf'."
	^ b view! !

!CachingVarFigures methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/28/2015 19:01'!
cachingVarsPerPackageGroupPie

| b  lb normalizer packagesToCachesWithMoreThanTen packagesToCachesWithLessThanTen lessThanTenAcc stats lessThanTenSize detectorStats allCaches |

stats := Dictionary new.
detectorStats := self packageAnalysisNumberOfCaches.
allCaches := cacheSet size.
packagesToCachesWithMoreThanTen := (detectorStats associations sort: [ :a :c | a value > c value ]) select: [ :assoc | assoc value >= 10 ]. 
packagesToCachesWithLessThanTen := (detectorStats associations sort: [ :a :c | a value > c value ]) select: [ :assoc | assoc value  < 10 ].
lessThanTenAcc := 0.
lessThanTenSize := packagesToCachesWithLessThanTen size. 
packagesToCachesWithLessThanTen do: [ :assoc | lessThanTenAcc := lessThanTenAcc + assoc value ].
packagesToCachesWithMoreThanTen do: [ :assoc | 
	stats at: (assoc key name , ' (' , assoc value asString ,')') put: assoc value.	
].

stats at: 'PkgGroups with < 10 Vars' , ' (' , lessThanTenAcc asString ,')'  put: lessThanTenAcc.
 
b := RTPieBuilder new.
b interaction popup.
b objects: stats keys.
b slice: [:x | stats at: x].
b normalizer distinctColor.	
b labelled.
"b emphasize: Set by: 20.
b emphasize: Dictionary by: 20."

"Legend"
lb := RTLegendBuilder new.
lb view: b view.
lb addText: allCaches asString , ' caches in ' , detectorStats size asString , ' package Groups out of ' , imageInfo packageGroupsToNumberOfClasses size asString , ' total packages groups in the system.' .
normalizer := RTMultiLinearColorForIdentity new objects: stats keys.
stats keys do: [ :package |
	lb addColor: (normalizer rtValue: package) text: package.
].
lb build.
b build.
b view setDefaultMenu; open.
"RTPDFExporter new exportCanvas: b view canvas onFileName: filePath , 'cachingVarsPerPackageGroupPie.pdf'.
"^ b view! !

!CachingVarFigures methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/29/2015 10:36'!
cachingVarsToNumberOfPackageGroupsGraph

	|b2   ds numberOfCachesToNumberOfPackages detectorStats |

	detectorStats := self packageAnalysisNumberOfCaches.
	numberOfCachesToNumberOfPackages := Dictionary new.

	detectorStats values asSet do: [:numberOfCaches |
		numberOfCachesToNumberOfPackages	at: numberOfCaches put: (detectorStats select: [:value | value = numberOfCaches]) size.
	].


	b2 := RTGrapher new.
	"b2 view: c view.
	b2 extent: 200 @ 150."

	ds := RTData new.
	"ds interaction popup."
	ds dotShape circle color: Color red.
	ds points: numberOfCachesToNumberOfPackages associations sort.
	ds x: [ :point | point key ].
	ds y: [ :point | point value ].
	ds connectColor: Color blue.
	"ds barShape rectangle color: Color lightBlue."
	b2 add: ds.
	"b2 axisX; axisYWithNumberOfTicks: 4.
	"
	b2 axisX noDecimal; title: 'Number of Caches'.
	b2 axisY noDecimal; title: 'Number of Packages'.
	b2 build.
	b2 view setDefaultMenu; open.
	^ b2 view! !

!CachingVarFigures methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/28/2015 18:58'!
exportFilePath: aFilepath

	filePath := aFilepath , '/'
	! !

!CachingVarFigures methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/8/2015 13:35'!
fixColoringFor: builder

	(builder view canvas shapes 
		select: [:shape | shape isKindOf: TRLabelShape])
		do: [ :label | label color: Color black ]! !

!CachingVarFigures methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/27/2015 20:32'!
importFromFuel: aFileName for: aCacheCollectionSubclass

	container := (aCacheCollectionSubclass importFromFuel: aFileName).
	cacheCollection := container collection.
	cacheSet := container collectionAsSet.
	imageInfo := container imageInfo. 
	! !

!CachingVarFigures methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/29/2015 11:54'!
minMax: aCollection
			
	^ aCollection min -> aCollection max
	! !

!CachingVarFigures methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/29/2015 11:05'!
packageAnalysisDensityOfCaches

	"easy and nice to have, plus it will help with analysis of third-party projects"

	| packageToNumberOfCachesDict packageToDensityOfCachesDict|
	packageToNumberOfCachesDict := self packageAnalysisNumberOfCaches.
	packageToDensityOfCachesDict := Dictionary new.
	packageToNumberOfCachesDict keysAndValuesDo: [ :key :value | 
		packageToDensityOfCachesDict at: key put: value asFloat / (imageInfo packageGroupsToNumberOfClasses at: key)
	].
	^ packageToDensityOfCachesDict
	! !

!CachingVarFigures methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/28/2015 18:13'!
packageAnalysisNumberOfCaches

	| packageGroupToNumberOfCaches |
	packageGroupToNumberOfCaches := Dictionary new.
	
	cacheSet do: [ :cvar | 
		packageGroupToNumberOfCaches 
			at: cvar packageGroup
			put: (packageGroupToNumberOfCaches at: cvar packageGroup ifAbsentPut: 0) + 1	
	].

	^ packageGroupToNumberOfCaches
	! !

!CachingVarFigures methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/29/2015 11:54'!
packageDensityMinMaxAvgDeviationOfDetectedSet

	|packageToDensityOfCaches|

	packageToDensityOfCaches := self packageAnalysisDensityOfCaches. 

	^ (self minMax: packageToDensityOfCaches values) -> (self averageAndDeviation: packageToDensityOfCaches values) 
	! !

!CachingVarFigures methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/29/2015 12:00'!
packageDistributionMinMaxAvgDeviationOfDetectedSet

	|packageToNumberOfCaches|

	packageToNumberOfCaches := self packageAnalysisNumberOfCaches. 

	^ (self minMax: packageToNumberOfCaches values) -> (self averageAndDeviation: packageToNumberOfCaches values) 
	! !
